#import "EasyLogPlugin.h"
#import <Foundation/Foundation.h>
#import <FBSDKCoreKit/FBSDKCoreKit.h>


@implementation EasyLogPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"easy_log"
            binaryMessenger:[registrar messenger]];
  EasyLogPlugin* instance = [[EasyLogPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([@"getPlatformVersion" isEqualToString:call.method]) {
    result([@"iOS " stringByAppendingString:[[UIDevice currentDevice] systemVersion]]);
  } else if ([@"logPageView" isEqualToString:call.method]) {
      
      result(nil);
  } else if ([@"beginPageView" isEqualToString:call.method]) {
      result(nil);
  } else if ([@"endPageView" isEqualToString:call.method]) {
      result(nil);
  } else if ([@"logEvent" isEqualToString:call.method]) {
      NSLog(@"FBAppEvent: %@, %@, %@,", @"logEvent", call.arguments[@"name"], call.arguments[@"label"]);
      [FBSDKAppEvents logEvent:call.arguments[@"name"]];
      result(nil);
  } else if([@"logEventWithAttributes" isEqualToString:call.method]) {
      NSLog(@"FBAppEvent: %@, %@, %@,", @"logEventWithAttributes", call.arguments[@"name"], call.arguments[@"attributes"]);
      if (call.arguments[@"attributes"] != [NSNull null])
          [FBSDKAppEvents logEvent:call.arguments[@"name"] parameters:call.arguments[@"attributes"]];
      else
      [FBSDKAppEvents logEvent:call.arguments[@"name"]];
      result(nil);
  } else if([@"logEventWithAttributesAndCounter" isEqualToString:call.method]) {
      NSLog(@"FBAppEvent: %@, %@, %@, %@", @"logEventWithAttributesAndCounter", call.arguments[@"name"], call.arguments[@"counter"], call.arguments[@"attributes"]);
      if (call.arguments[@"counter"] != [NSNull null]) {
          NSNumber *number = call.arguments[@"counter"];
          [FBSDKAppEvents logEvent:call.arguments[@"name"] valueToSum:number.intValue parameters:call.arguments[@"attributes"]];
      } else if (call.arguments[@"attributes"] != [NSNull null]) {
          [FBSDKAppEvents logEvent:call.arguments[@"name"] parameters:call.arguments[@"attributes"]];
      } else {
        [FBSDKAppEvents logEvent:call.arguments[@"name"]];
      }
      result(nil);
  } else {
    result(FlutterMethodNotImplemented);
  }
}

@end
