import './easy_log_base.dart';

import 'package:flutter/services.dart';

class EasyLogFacebook implements EasyLogBase {

  factory EasyLogFacebook() => _sharedInstance();
  static EasyLogFacebook _instance;
  EasyLogFacebook._();
  static EasyLogFacebook _sharedInstance() {
    if (_instance == null) {
    _instance = EasyLogFacebook._();
    }
    return _instance;
  }

  MethodChannel _channel = const MethodChannel('easy_log');

  void event(String eventId) {
    _channel.invokeMethod("logEvent", {"name": eventId});
  }

  void eventWithLabel(String eventId, String label) {
    _channel.invokeMethod("logEvent", {"name": eventId, "label": label});
  }

  void eventWithAttributes(String eventId, Map<String, String> attributes) {
    _channel.invokeMethod("logEventWithAttributes", {"name": eventId, "attributes": attributes});
  }

  void eventWithAttributesAndCounter(String eventId, Map<String, String> attributes, int number) {
    _channel.invokeMethod("logEventWithAttributesAndCounter", {"name": eventId, "attributes": attributes, "counter": number});
  }

  void beginLogPageView(String pageName) {
    print('Facebook ' + 'begin' + pageName);
  }

  void endLogPageView(String pageName) {
    print('Facebook ' + 'end' + pageName);
  }
}